Bug 857843 - Review Request: lessjs - Less.js The dynamic stylesheet language
Review Request: lessjs - Less.js The dynamic stylesheet language
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Fabian Deutsch
Fedora Extras Quality Assurance
:
: 911184 (view as bug list)
Depends On: 815018
Blocks: 845479 950041
  Show dependency treegraph
 
Reported: 2012-09-17 04:14 EDT by Matthias Runge
Modified: 2013-04-09 10:01 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-01-02 07:32:57 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
fabian.deutsch: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Matthias Runge 2012-09-17 04:14:31 EDT
Spec URL: http://www.matthias-runge.de/fedora/lessjs.spec
SRPM URL: http://www.matthias-runge.de/fedora/lessjs-1.3.0-20120917git55d6e5a.1.fc17.src.rpm
Description: LESS extends CSS with dynamic behavior such as variables, mixins, operations 
and functions. LESS runs on both the client-side (Chrome, Safari, Firefox) 
and server-side, with Node.js and Rhino. 

Fedora Account System Username: mrunge
Comment 1 Stephen Gallagher 2012-12-13 15:22:18 EST
I took a look at this and cleaned it up some. This package review is blocking the upgrade of ReviewBoard 1.7, so it's in my interest to get this in shape once the Node.js package lands.

Spec: http://sgallagh.fedorapeople.org/packagereview/lessjs/lessjs.spec
SRPM: http://sgallagh.fedorapeople.org/packagereview/lessjs/lessjs-1.3.1-1.fc18.src.rpm


The only real changes here are an upgrade to 1.3.1 and pointing it at a cleaner tarball location. We can't have it point at master because this isn't repeatable (that returns different results every time someone commits to the repo).

There's also a bug in the 1.3.1 release that caused it to display the version as 1.3.0 when 'lessc -v' was called, so I fixed that too.
Comment 2 Matthias Runge 2012-12-14 02:41:26 EST
Thanks Stephen! Cleaning up is greatly appreciated.
Comment 3 Matthias Runge 2012-12-19 02:59:02 EST
lessjs uses cssmin.js to shrink css code.

The usage of cssmin.js is harmless; yui compressor is deprecated by its upstream, and currently lessjs is the only package using that:
yum search */cssmin.js
Loaded plugins: langpacks, presto, refresh-packagekit
Warning: No matches found for: */cssmin.js
No Matches found

Reference upstream:
- http://www.yuiblog.com/blog/2012/10/16/state-of-yui-compressor/

Also, one may assume, there's a general exception for JavaScript libraries from strictly no bundling policy:

http://fedoraproject.org/wiki/Packaging:Guidelines#Duplication_of_system_libraries

Nevertheless, I did some minor tweaks:

SPEC: http://www.matthias-runge.de/fedora/lessjs.spec
SRPM: http://www.matthias-runge.de/fedora/lessjs-1.3.1-2.fc18.src.rpm

it builds in koji: 
http://koji.fedoraproject.org/koji/taskinfo?taskID=4802144

and still has some spelling warnings:
[mrunge@turing SPECS]$ rpmlint ./lessjs.spec ../RPMS/noarch/lessjs-1.3.1-2.fc18.noarch.rpm ../SRPMS/lessjs-1.3.1-2.fc18.src.rpm 
./lessjs.spec:12: W: macro-in-comment %{version}
./lessjs.spec: W: invalid-url Source0: less.js-1.3.1.tar.gz
lessjs.noarch: W: spelling-error Summary(en_US) js -> dis, ks, j
lessjs.noarch: W: spelling-error Summary(en_US) stylesheet -> style sheet, style-sheet, stylishness
lessjs.noarch: W: spelling-error %description -l en_US mixins -> mixing, mix ins, mix-ins
lessjs.noarch: W: spelling-error %description -l en_US js -> dis, ks, j
lessjs.noarch: W: no-documentation
lessjs.noarch: W: no-manual-page-for-binary lessc
lessjs.src: W: spelling-error Summary(en_US) js -> dis, ks, j
lessjs.src: W: spelling-error Summary(en_US) stylesheet -> style sheet, style-sheet, stylishness
lessjs.src: W: spelling-error %description -l en_US mixins -> mixing, mix ins, mix-ins
lessjs.src: W: spelling-error %description -l en_US js -> dis, ks, j
lessjs.src:12: W: macro-in-comment %{version}
lessjs.src: W: invalid-url Source0: less.js-1.3.1.tar.gz
2 packages and 1 specfiles checked; 0 errors, 14 warnings.
Comment 4 Fabian Deutsch 2012-12-19 04:43:22 EST
Hey Matthias,

the main issue is see is the (possible) bundling of cssmin.js. To me it's not obvious if it's just bundling or a fork of cssmin.js. Please clarify this with upstream and note it in the spec.

Now that we've come to the end of this lengthy review, it's time to say that you should also add the LICENSE file to %doc.

- fabian


Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
[!]: Package contains no bundled libraries.
     It seems as i cssmin.js is a modified copy or fork of
     https://github.com/stoyan/yuicompressor/blob/master/ports/js/cssmin.js
     https://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries#Copylibs
[!]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
     LICENSE is missing from %doc, you could also add README.md
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. No licenses
     found. Please check the source files for licenses manually.
[!]: Requires correct, justified where necessary.
     Might need an update if cssmin.js is an extra package.

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[-]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[!]: Package contains no bundled libraries.
     It seems as i cssmin.js is a modified copy or fork of
     https://github.com/stoyan/yuicompressor/blob/master/ports/js/cssmin.js
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[-]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[-]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[!]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
     LICENSE is missingfrom %doc, you could also add README.md
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. No licenses
     found. Please check the source files for licenses manually.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec.
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[-]: Package is not relocatable.
[!]: Requires correct, justified where necessary.
     Might need an update if cssmin.js is an extra package.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[!]: SourceX / PatchY prefixed with %{name}.
     Note: Source0 (less.js-1.3.1.tar.gz)
[x]: SourceX is a working URL.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: lessjs-1.3.1-2.fc19.src.rpm
          lessjs-1.3.1-2.fc19.noarch.rpm
lessjs.src: W: spelling-error Summary(en_US) js -> dis, ks, j
lessjs.src: W: spelling-error Summary(en_US) stylesheet -> style sheet, style-sheet, stylishness
lessjs.src: W: spelling-error %description -l en_US mixins -> mixing, mix ins, mix-ins
lessjs.src: W: spelling-error %description -l en_US js -> dis, ks, j
lessjs.src:12: W: macro-in-comment %{version}
lessjs.src: W: invalid-url Source0: less.js-1.3.1.tar.gz
lessjs.noarch: W: spelling-error Summary(en_US) js -> dis, ks, j
lessjs.noarch: W: spelling-error Summary(en_US) stylesheet -> style sheet, style-sheet, stylishness
lessjs.noarch: W: spelling-error %description -l en_US mixins -> mixing, mix ins, mix-ins
lessjs.noarch: W: spelling-error %description -l en_US js -> dis, ks, j
lessjs.noarch: W: no-documentation
lessjs.noarch: W: no-manual-page-for-binary lessc
2 packages and 0 specfiles checked; 0 errors, 12 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint lessjs
lessjs.noarch: W: spelling-error Summary(en_US) js -> dis, ks, j
lessjs.noarch: W: spelling-error Summary(en_US) stylesheet -> style sheet, style-sheet, stylishness
lessjs.noarch: W: spelling-error %description -l en_US mixins -> mixing, mix ins, mix-ins
lessjs.noarch: W: spelling-error %description -l en_US js -> dis, ks, j
lessjs.noarch: W: no-documentation
lessjs.noarch: W: no-manual-page-for-binary lessc
1 packages and 0 specfiles checked; 0 errors, 6 warnings.
# echo 'rpmlint-done:'
Comment 5 Matthias Runge 2012-12-19 04:57:45 EST
Since cssmins is deprecated by its own upstream, I consider this here as a fork, maintained by less.js upstream

I also opened an issue at less.js upstream to unbundle/remove:
https://github.com/cloudhead/less.js/issues/1080
Comment 6 Matthias Runge 2012-12-19 05:02:31 EST
Update to include LICENSE and README.md in %doc

SPEC: http://www.matthias-runge.de/fedora/lessjs.spec
SRPM: http://www.matthias-runge.de/fedora/lessjs-1.3.1-3.fc18.src.rpm
Comment 7 Stephen Gallagher 2012-12-19 09:26:58 EST
Additional updates to unbundle cssmin.js. We're going to just block the --yui-compress command-line flag and throw an error if it's specified for now. The application is still useful without it (and there is an alternate --compress option as well). The build now suppresses the installation of the cssmin.js file as well.

I also converted the assorted manual actions occurring in the %prep section into patches.

SPEC: http://sgallagh.fedorapeople.org/packagereview/lessjs/lessjs.spec
SRPM: http://sgallagh.fedorapeople.org/packagereview/lessjs/lessjs-1.3.1-1.fc18.src.rpm

Koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=4802757
Comment 9 Fabian Deutsch 2012-12-19 11:33:04 EST
Stephen,

the latest spec is nearly fine for me.
You need to adjust the License field again as cssmin.js is removed now.

And a last small nitpick: You could use rm instead of the 0004-Remove-pre-builds.patch - but that's just my pov.
Comment 10 Fabian Deutsch 2012-12-19 11:49:07 EST
As discussed on IRC, both lciense should stay in the field, as we still ship cssmin.js, but remove it.

Therefor,

Package approved.
Comment 11 Stephen Gallagher 2012-12-19 11:55:35 EST
New Package SCM Request
=======================
Package Name: lessjs
Short Description: Less.js The dynamic stylesheet language
Owners: sgallagh mrunge
Branches: f18 f17 el6
InitialCC:
Comment 12 Jon Ciesla 2012-12-19 12:05:19 EST
Git done (by process-git-requests).
Comment 13 Fedora Update System 2013-01-07 06:35:10 EST
lessjs-1.3.1-4.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/lessjs-1.3.1-4.fc18
Comment 14 Fedora Update System 2013-01-16 14:21:16 EST
lessjs-1.3.1-4.fc18 has been pushed to the Fedora 18 stable repository.
Comment 15 Jamie Nguyen 2013-03-15 06:04:00 EDT
*** Bug 911184 has been marked as a duplicate of this bug. ***

Note You need to log in before you can comment on or make changes to this bug.